#!/usr/bin/perl -w
;########################################################################
;###	mtbbs-create-entry.cgi
;###	@see http://www.magicvox.net/archive/2006/05172324.php
;###			Programmed by Piroli YUKARINOMIYA (MagicVox)
;###			Open MagicVox.net - http://www.magicvox.net/

use vars qw( $VERSION );
$VERSION = '0.20';

use strict;
use lib 'lib';
use lib 'extlib';
use CGI;
;#use CGI::Carp qw(fatalsToBrowser);#DEBUG
;#use Data::Dumper;#DEBUG
use MT;
use MT::App;
use MT::Blog;
use MT::Entry;
use MT::Placement;
use MT::IPBanList;
use MT::Util;

;########################################################################

;# BlogID number of which a new entry posted.
use constant BLOG_ID =>					1;
;# AuthorID number of which a new entry can be posted.
use constant AUTHOR_ID =>				1;

;# Default category ID of posted entry when user specified no category
use constant DEFAULT_CATEGORY_ID =>		undef;# root category
;#use constans DEFAULT_CATEGORY_ID =>		1;# specified category id

;# Initial state of newly posted entry.
use constant INIT_STATUS =>				MT::Entry::RELEASE();# Published
;#use constant INIT_STATUS =>				MT::Entry::HOLD();# Unpublished

;# Default state of allowing comment form
;# 0) Nothing, 1) Open, 2) Close
use constant DEFAULT_ALLOW_COMMENTS =>	1;

;# Redirect when some error occured (if you don't use this feature, set undef)
use constant URL_ERROR =>				undef;
;#use constant URL_ERROR =>			'/error.html';

;# Redirect when invoked from denied remote host (if you don't use this feature, set undef)
use constant URL_IPBANNED =>			undef;
;#use constant URL_IPBANNED =>			'/ip_banned.html';

;# Redirect after a new entry posted successfully
use constant URL_SUCCEED =>				'./';

;# Set 1 to check if each field is empty.
use constant CHECK_EMPTY_TITLE =>		0;
use constant CHECK_EMPTY_TEXT =>		0;
use constant CHECK_EMPTY_TEXT_MORE =>	0;
use constant CHECK_EMPTY_EXCERPT =>		0;
use constant CHECK_EMPTY_KEYWORDS =>	0;
use constant CHECK_EMPTY_CATEGORY =>	0;



;########################################################################

my $q = new CGI;

;# Retrieve the instance of MT
my $mt = MT->new;

;# Check with IPBanList
my $iter = MT::IPBanList->load_iter ({ blog_id => BLOG_ID });
while (my $ban = $iter->()) {
	my $banned_ip = $ban->ip;
	if ($ENV{'REMOTE_ADDR'} =~ /$banned_ip/) {
		if (URL_IPBANNED) {
			redirect_to (URL_IPBANNED);
		}
		die MT->translate ('You are not allowed to post comments.');
	}
}


;# it should be a good idea to check with ThrottleFilter here ...


;# Create an instance of entry
my $entry = MT::Entry->new;
$entry->blog_id (BLOG_ID);
$entry->status (INIT_STATUS);
$entry->author_id (AUTHOR_ID);

$entry->allow_comments (DEFAULT_ALLOW_COMMENTS);

;# Title
redirect_to (URL_ERROR)
	if CHECK_EMPTY_TITLE && ! defined $q->param ('title');
$entry->title ($q->param ('title'))
	if $q->param ('title');
;# Text (body)
redirect_to (URL_ERROR)
	if CHECK_EMPTY_TEXT && ! defined $q->param ('text');
$entry->text ($q->param ('text'))
	if $q->param ('text');
;# TexoMore (extends)
redirect_to (URL_ERROR)
	if CHECK_EMPTY_TEXT_MORE && ! defined $q->param ('text_more');
$entry->text_more ($q->param ('text_more'))
	if $q->param ('text_more');
;# Excerpt
redirect_to (URL_ERROR)
	if CHECK_EMPTY_EXCERPT && ! defined $q->param ('excerpt');
$entry->excerpt ($q->param ('excerpt'))
	if $q->param ('excerpt');
;# Keywords
redirect_to (URL_ERROR)
	if CHECK_EMPTY_KEYWORDS && ! defined $q->param ('keywords');
$entry->keywords ($q->param ('keywords'))
	if $q->param ('keywords');

;# Category
my $cat_id = $q->param ('category');
redirect_to (URL_ERROR)
	if CHECK_EMPTY_CATEGORY && ! $cat_id;
$cat_id = DEFAULT_CATEGORY_ID unless $cat_id;


;# Save a entry
if (! $entry->save) {
	if (URL_ERROR) {
		redirect_to (URL_ERROR);
	}
	die MT->translate ('Execute failure - Entry->save');
}


;# Touch and Save this blog
my $blog = MT::Blog->load (BLOG_ID);
if (! $blog) {
	if (URL_ERROR) {
		redirect_to (URL_ERROR);
	}
	die MT->translate ('Execute failure - Blog->load');
}
$blog->touch ();
if (! $blog->save ()) {
	if (URL_ERROR) {
		redirect_to (URL_ERROR);
	}
	die MT->translate ('Execute failure - Blog->save');
}


;# Set a category to this entry
if ($cat_id) {
	my $place = MT::Placement->load({ entry_id => $entry->id, is_primary => 1 });
	unless ($place) {
		$place = MT::Placement->new;
		$place->entry_id ($entry->id);
		$place->blog_id ($entry->blog_id);
		$place->is_primary (1);
	}
	$place->category_id ($cat_id);
	$place->save;
}


;# Rebuild the blog including this entry
MT::Util::start_background_task (sub {
		if ($mt) {
			$mt = $mt->publisher if (3.2 <= MT->version_number);
			if ($mt) {
				$mt->rebuild (BlogID => BLOG_ID);
			}
		}
});


;# Redirect in successful
redirect_to (URL_SUCCEED);



;### Redirect to specified URL
sub redirect_to {
	my ($url) = @_;
;#
	print $q->redirect ($url);
	exit;
}

;########################################################################
